@q Copyright 2012-2020, Alexander Shibakov@>
@q This file is part of SPLinT@>

@q SPLinT is free software: you can redistribute it and/or modify@>
@q it under the terms of the GNU General Public License as published by@>
@q the Free Software Foundation, either version 3 of the License, or@>
@q (at your option) any later version.@>

@q SPLinT is distributed in the hope that it will be useful,@>
@q but WITHOUT ANY WARRANTY; without even the implied warranty of@>
@q MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the@>
@q GNU General Public License for more details.@>

@q You should have received a copy of the GNU General Public License@>
@q along with SPLinT.  If not, see <http://www.gnu.org/licenses/>.@>

@** Bibliography. This list of references is not meant to be
exhaustive or complete. These are merely the papers and the books
mentioned in the body of the program above. Naturally, this project
has been influenced by many outside ideas but it would be impossible
to list them all due to time and (human) memory limitations.

{%
\def\BASIX{{B\kern-.7ptA\kern-.7ptS\kern-.3pt\lower1.3pt\hbox{I}\kern-.3pt X}}
\def\bterm#1{\item{[#1]\namedspot{#1bibref}\quad}\ignorespaces}%
\setbox0=\hbox{[ISO/C11]\quad}
\parindent=0pt
\advance\parindent by \wd0
\ninepoint
\smallskip
\centerline{\dinkus}%
\smallskip

\bterm{ACM}Ronald M.~Baecker, Aaron~Marcus, {\it Human Factors and Typography for More Readable Programs},
Reading, Massachusetts: Addison-Wesley, 1990, xx+344~pp.

\bterm{Ah}Alfred V.~Aho et al., {\it Compilers: Principles,
Techniques, and Tools}, Pearson Education, 2006.

\bterm{Bi}Charles Donnelly and Richard Stallman, {\it Bison, The
Yacc-compatible Parser Generator}, The Free Software Foundation, 2013.
\url{http://www.gnu.org/software/bison/}

\bterm{CWEB}Donald E. Knuth and Silvio Levy {\it The \CWEB\ System of Structured Documentation},
Reading, Massachusetts: Addison-Wesley, 1993, iv+227~pp.

\bterm{DEK1}Donald E.~Knuth, {\it The \TeX book}, Addison-Wesley Reading, Massachusetts, 1984.

\bterm{DEK2}Donald E.~Knuth {\it The future of \TeX\ and \MF}, TUGboat {\bf 11} (4), p.~489, 1990.

\bterm{DHB}R.~Kent Dybvig, Robert Hieb, and Carl Bruggeman, {\em Syntactic Abstraction in Scheme},
Lisp Symb.\ Comput.\ 5, {\bf 4} (Dec.~1992), pp.~295--326.

\bterm{Do}Jean-luc Doumont, {\it Pascal pretty-printing: an example of ``preprocessing with \TeX''},
TUGboat {\bf 15} (3), 1994---Proceedings of the 1994 TUG Annual Meeting

\bterm{Er}Sebastian Thore Erdweg and Klaus Ostermann, {\it Featherweight \TeX\ and Parser Correctness},
Proceedings of the Third International Conference on Software Language Engineering,
pp.\ 397--416, Springer-Verlag Berlin, Heidelberg {\bf 2011}. 

\bterm{Fi}Jonathan Fine, {\it The \.{\\CASE} and \.{\\FIND} macros},
TUGboat {\bf 14} (1), pp.~35--39, 1993.

\bterm{Go}Pedro Palao Gostanza, {\it Fast scanners and self-parsing in \TeX},
TUGboat {\bf 21} (3), 2000---Proceedings of the 2000 Annual Meeting.

\bterm{Gr}Andrew Marc Greene, {\it \BASIX---an interpreter written in \TeX}, TUGboat {\bf 11} (3), 
1990---Proceedings of the 1990 TUG Annual Meeting.

\bterm{Ha}Hans Hagen, {\it Lua\TeX: Halfway to version~1}, TUGboat
{\bf 30} (2), pp.~183--186, 2009. \url{http://tug.org/TUGboat/tb30-2/tb95hagen-luatex.pdf}.

\bterm{Ho}Taco Hoekwater, {\it Lua\TeX\ says goodbye to Pascal}, TUGboat {\bf 30} (3), 
pp.~136--140, 2009---Euro\TeX\ 2009 Proceedings.

\bterm{Ie}R.~Ierusalimschy et al., {\it Lua~5.1 Reference Manual},
{\tt Lua.org}, August 2006. \url{http://www.lua.org/manual/5.1/}.

\bterm{ISO/C11}{\it ISO/IEC 9899---Programming languages---C (C11)}, December~2011, draft available at
\url{http://www.open-std.org/jtc1/sc22/wg14/www/docs/n1570.pdf}

\bterm{Jo}Derek M.~Jones, {\it The New C Standard: An Economic and
Cultural Commentary}, available at \url{http://www.knosof.co.uk/cbook/cbook.html}.

\bterm{KR}B.~Kernighan, D.~Ritchie, {\it The \Cee\ programming language}, Englewood Cliffs, NJ: Prentice Hall, 1978.

\bterm{La}{\it The \.{l3regex} package: regular expressions in \TeX},  The \LaTeX3\ Project.

\bterm{Pa}Vern Paxson et al., {\it Lexical Analysis With Flex, for
Flex~2.5.37}, July~2012. \url{http://flex.sourceforge.net/manual/}.

\bterm{Ra}Norman Ramsey, {\it Literate programming simplified}, IEEE Software, {\bf 11} (5),
pp.~97--105, 1994.

\bterm{Sh}Alexander Shibakov, {\it Parsers in \TeX\ and using \CWEB\ for general pretty-printing},
TUGboat {\bf 35} (1), 2014, available as part of the documentation supplied with \splint.

\bterm{Wo}Marcin Woli\'nski, {\it {\tt Pretprin}---a \LaTeX2$\epsilon$ package for 
pretty-printing texts in formal languages},
TUGboat {\bf 19} (3), 1998---Proceedings of the 1998 TUG Annual Meeting.

}